/* 
 * CSE142, Spring 1999				BRIAN ALTMAN
 * Homework 4						
 * Traffic animation				  SECT: AE
 */

#include "gp142.h"
#include <stdio.h>
#include <math.h>

/* Logical constants */
#define TRUE    		1
#define FALSE   		0
#define DAY 2
#define NIGHT 3

#define FILL 0

/* Menu buttons: */

/* Top-left coordinates of button palette */
#define MENU_TOP		(GP142_YMAX - 5)
#define MENU_LEFT		(-GP142_XMAX + 5)

/* Height and width of buttons in pixels */
#define BUTTON_HEIGHT  	25
#define BUTTON_WIDTH 	99

/* Number of buttons */
#define NUM_BUTTONS 	11

/*   Mouse click in some button */
#define BUTTON_CLICK 1

/*   Mouse click elsewhere */
#define OTHER_CLICK 0

/* Coordinates of objects in the drawing */

/* y-coordinate of the top of the ground in the landscape */
#define HORIZON (- 2 * (GP142_YMAX / 25))

/* Vertical center and width of highway */
#define HIGHWAY_CENTER ((-GP142_YMAX + HORIZON) * 6/10)
#define HIGHWAY_WIDTH  10

/* Maximum number of vehicles that can appear in the animation */
#define MAX_VEHICLES	1

/* Height and width of a single car */
#define CAR_HEIGHT 22
#define CAR_WIDTH  38

/* Height and width of a boat */
#define BOAT_HEIGHT 32
#define BOAT_WIDTH  48

/*Array definitions */
#define NUM_CARS 11
#define NUM_TRUCKS 10
#define NUM_BIULDING_1  10
#define NUM_BIULDING_2  4
#define NUM_STARS 60
#define NUM_ASTEROID 10
#define NUM_TREES 29
	/*Used to store y-coord values of truck and car*/
#define Y_CAR_LN1	HIGHWAY_CENTER -9
#define Y_CAR_LN2	HIGHWAY_CENTER -39
#define Y_TRUCK_LN1 HIGHWAY_CENTER 
#define Y_TRUCK_LN2 HIGHWAY_CENTER -30

/*****************************************************************************

     FUNCTION PROTOTYPES

*****************************************************************************/

/* Draw the background, including the sun at coordinates sun_x and sun_y */
int draw_landscape(int sun_x, int sun_y, int moon_x, int moon_y, 
				   int y1, int y2, int setting, int boat_x, int boat_y, 
				   int boat_color, const int left_side_1[], 
				   const int base_1[], const int biulding_color_1[],
				   const int left_side_2[], const int base_2[], 
				   const int biulding_color_2[], const int star_x[],
				   const int star_y[]);


/* Draw the buttons */
void draw_buttons(int setting);

/* Return kind of mouse click (in a button, etc.) */
int  classify_mouse_click(int mouse_x, int mouse_y);

/* Process button click at location x, y.  Update car speed,  */
/* direction, color, and whether traffic is moving as needed. */
void handle_button(int x, int y, int *traffic_moving, int *car_speed,
				   int *car_num, int car_direction[], int *truck_num, 
				   int truck_direction[], int car_color[], 
				   int truck_color[], int *asteroid);

/* Update sun coordinates sun_x, sun_y for one tick */
void move_sun(int *sun_x, int *sun_y, int *moon_x);

/*Update Space Needle elavator y-coordinates*/
void move_elavator(int *y1, int *y2);

/* Update all vehicle x, y coordinates, given current x, y */
/* location, direction (+1 or -1), and speed in pixels per tick. */
void move_traffic(int car[], int truck[], int car_direction[], 
				  int truck_direction[], int speed);

void move_boat(int *boat_x, int *boat_y, int *boat_direction, 
			   int boat_speed);

/* Draw all vehicles given their current x, y coordinates and color */
void draw_traffic(int truck_num, const int truck_x[], const int truck_y[],
				const int truck_color[], const int truck_direction[],
				int car_num, const int car_x[], const int car_y[], 
				const int car_color[], const int car_direction[], 
				int setting);

void draw_boat_traffic(int x, int y, int boat_color, int setting);

/* Draw a single car of the given color with horizontal */
/* center x and bottom y*/
void draw_car(int car_num, const int x[], const int y[], const int color[], 
			  const int car_direction[], int setting);

/* Draw a truck same as car variables****/
void draw_truck(int truck_num, const int x[], const int y[], 
				const int color[], const int truck_direction[], 
				int setting);

/*Draw a boat same as car variables***/
void draw_boat(int x, int y, int boat_color, int setting);

/*Draw biulding*/
void draw_biulding(int setting, int windows, 
				   const int left_side[], 
				   const int base[], 
				   const int color[]);
void draw_biulding_2(int setting, int windows, 
				   const int left_side[], 
				   const int base[], 
				   const int color[]);

void draw_tree(const int tree_x[], const int tree_y[]);

/*Update moon coordinates moon_x, moon_y for one tick*****/
void move_moon(int *moon_x, int *moon_y, int *sun_x);

/*Function that performs VALCANO!!!*****/
void seattle_goes_boom(int ast_x[], int ast_y[], int ast_x1[],
							int ast_y1[], int *size);

/*Function that performs volcano action slide 1*/
void draw_landscape_asteroid(int ast_x[], int ast_y[], int ast_x1[],
							int ast_y1[], int size);
/*****************************************************************************

     MAIN

*****************************************************************************/

/*
 * Main program contents:
 *   - Major program variables that persist throughout execution
 *   - Event loop that processes GP142 events until the user quits,
 *     and updates variables and redraws the window as needed.
 */
int main(void)
{
	/* Event handling and buttons: */
	int  quit;				/* = "user has selected quit"				*/
	int  event;				/* the most recent GP142 event				*/
	char key_pressed;		/* last keyboard character from key event	*/
	int  mouse_x, mouse_y;	/* x and y coordinates of latest mouse event*/
	int  click_kind;		/* kind of mouse click (button, etc.)		*/
	int asteroid;
	int size;
	/* Information about the sun and moon: */
	int sun_x, sun_y;			/* screen x and y coordinates */
	int moon_x, moon_y;
	int setting;

	/* Information about vehicles in the animation:							*/
	int speed;  /* speed in pixels per tick when traffic moving	*/	
	int traffic_moving;	/* = "traffic is currently moving"				*/
	int boat_x;
	int boat_y;
	int boat_direction;
	int boat_color;
	int boat_speed;
	int y1, y2;
	int car_num = 1, truck_num =1;
		/*Initialization of arrays for drawing biuldings*/
/* biuldings are biult left to right and from water edge to highway*/
	/*biulding one*/

	int left_side_1[NUM_BIULDING_1] = {-GP142_XMAX +100, 
			GP142_XMAX -135, -GP142_XMAX +45, GP142_XMAX -95, 
			-GP142_XMAX +15, GP142_XMAX -64, -145, 105, -205, 150};

	int base_1[NUM_BIULDING_1] = {HORIZON - 30, HORIZON - 50, 
			HORIZON - 76, HORIZON - 100, HORIZON - 125, HORIZON - 115,
			HORIZON - 107, HORIZON - 96, HORIZON - 120, HORIZON - 125};

	int biulding_color_1[NUM_BIULDING_1] = {LT_GRAY, RED, 
			GOLD, DUSTY_PLUM, LT_GRAY, MED_GRAY, DUSTY_PLUM, 
			ORANGE, MED_GRAY, LT_GRAY};

	/*biulding two*/
	int left_side_2[NUM_BIULDING_2] = {-GP142_XMAX +24, -71, 
			65, GP142_XMAX -65,};

	int base_2[NUM_BIULDING_2] = {HORIZON - 30,	HORIZON - 100, 
			 HORIZON - 65, HORIZON - 33};

	int biulding_color_2[NUM_BIULDING_2] = {MED_GRAY, LT_GRAY, 
			GOLD, CHALK};

/*Initialization of Star array*/
	int star_x[NUM_STARS] = {-140,-33,-256,-94,-43,-218,-32,-123,-56,
			-155, -225,-43,-77,-83,-93,-168,-34,-19,-139,-213,-174,
			-88,-119,-201,-183,-149,-282,-173,-162,122,233,146,221,
			243,282,143,168,121,183,195,219,211,139,123,163,34,134,83,
			243,162,264,19,215,112,0,278,179,159,63,287};

	int star_y[NUM_STARS] = {179,200,171,211,215,231,239,186,235,
			194,165,179,175,168,181,221,224,236,234,224,212,
			154,132,127,112,202,191,150,216,129,148,158,154,114,165,
			229,125,98,124,164,201,162,173,154,231,278,98,241,148,
			238,236,245,248,223,226,234,174,145,227,197};

	
		/*Initialize array for cars*/
	int car_x[NUM_CARS] = {0,0,-170,92,131,-167, 200, -313,-259,374,-404};
	int car_y[NUM_CARS] = {Y_CAR_LN1, Y_CAR_LN2, Y_CAR_LN1, Y_CAR_LN2, 
		Y_CAR_LN1, Y_CAR_LN2, Y_CAR_LN1, Y_CAR_LN2, Y_CAR_LN1, 
		Y_CAR_LN2, Y_CAR_LN2};
	int car_color[NUM_CARS] = {RED, BLUE, GREEN, LT_GRAY, ORANGE, 
					TURQUOISE, PURPLE, GOLD, PEACH, CHALK, CYAN};
	int car_direction[NUM_CARS] = {1, -1, 1, -1, 1, -1, 1, -1, 1, -1, -1};

	/* current direction: +1=right, -1=left*/
	/*Initialize array for trucks*/
	int truck_x[NUM_TRUCKS] = {100,-GP142_XMAX +55,200,209,385,-115,-73,50,267,
								320};
	int truck_y[NUM_TRUCKS] = {Y_TRUCK_LN1, Y_TRUCK_LN2, Y_TRUCK_LN1, 
		Y_TRUCK_LN2, Y_TRUCK_LN1, Y_TRUCK_LN2, Y_TRUCK_LN1, Y_TRUCK_LN2, 
		Y_TRUCK_LN1, Y_TRUCK_LN2};
	int truck_color[NUM_TRUCKS] = {GOLD, ORANGE, BLUE, RED, PINK, 
		PURPLE, MED_GRAY, FOREST_GREEN, DUSTY_PLUM, LT_GRAY};	
	int truck_direction[NUM_TRUCKS] ={1, -1, 1, -1, 1, -1, 1, -1, 1, -1};

	/*Initialize tree variables- 1st # are below highway, rest are 
				in park. Trees are 20 pixels wide and 40 pixels high*/

	int tree_x[NUM_TREES] = {GP142_XMAX -25, GP142_XMAX-50, GP142_XMAX-75, 
					GP142_XMAX-100, GP142_XMAX-125, GP142_XMAX-150, 
					GP142_XMAX-175, GP142_XMAX-200, GP142_XMAX-31, 
					GP142_XMAX-63, GP142_XMAX-89, GP142_XMAX-285, 
					GP142_XMAX-160, GP142_XMAX-190, GP142_XMAX-235,
				-GP142_XMAX+222, -GP142_XMAX+354, -GP142_XMAX+199, 
				-GP142_XMAX+290, -GP142_XMAX+327, -GP142_XMAX+301, 
				-GP142_XMAX+240, -GP142_XMAX+181, -GP142_XMAX+259, 
				-8, 35, 67, 52, 80};

	int tree_y[NUM_TREES] = {-GP142_YMAX+36, -GP142_YMAX+19, 
				-GP142_YMAX+4, -GP142_YMAX+38, -GP142_YMAX+13, 
				-GP142_YMAX+10,	-GP142_YMAX+38, -GP142_YMAX+27, 
				-GP142_YMAX+15,	-GP142_YMAX+35, -GP142_YMAX+1, 
				-GP142_YMAX+5, -GP142_YMAX+2, -GP142_YMAX+22, 
				-GP142_YMAX+27,	-GP142_YMAX+31, -GP142_YMAX+7, 
				-GP142_YMAX+15,	-GP142_YMAX+39, -GP142_YMAX+20, 
				-GP142_YMAX+8, -GP142_YMAX+5, -GP142_YMAX+22, 
				-GP142_YMAX+11, -96, -103, -139, -92, -123};

	/*Initialize asteroid variables*/
	int ast_x[NUM_ASTEROID] = {-73,220,250,300,252,-45,307,341,173,
				411};

	int ast_y[NUM_ASTEROID] = {GP142_YMAX+8, GP142_YMAX+28,
		GP142_YMAX+45, GP142_YMAX+52, GP142_YMAX+19,GP142_YMAX+67,
		 GP142_YMAX+103,GP142_YMAX+143, GP142_YMAX+77,GP142_YMAX+113};
	
	int ast_x1[(NUM_ASTEROID)] = {26,18,-119,-148,-171,-229,-101,
				-283,-421, 1};
	int ast_y1[(NUM_ASTEROID)] = {GP142_YMAX+5, GP142_YMAX+47,
		GP142_YMAX+59, GP142_YMAX+39, GP142_YMAX+64, GP142_YMAX+90,
		GP142_YMAX+109, GP142_YMAX+131, GP142_YMAX+105,GP142_YMAX+102};
		
	/* Initialize graphics package, clear the window,	*/
	/* turn logging off, and start animation.			*/
	GP142_open();
	GP142_logging(LOG_OFF);
	GP142_clear();
	GP142_animate(ANI_RUN);

	/* set initial location of the sun */
	sun_x = GP142_XMAX - 25;
	sun_y = GP142_YMAX - 35;

	/* set initial location of the moon */
	moon_x = GP142_XMAX - 25;
	moon_y = GP142_YMAX - 35;
	
	/*Set initaial cordinates of Space Needle elavator*/
	y1 = HORIZON -50;
	y2 = HORIZON -43;

	/* set initial conditions for the lane 1 */
	speed = 13;
	traffic_moving = TRUE;
	
	/*Set initial conditions for boat lane */
	boat_x = 0;
	boat_y = HORIZON +20;
	boat_direction = +1;
	boat_color = car_color[0];
	boat_speed = 1;
	
	/* Iitialize valcano and setting*/
	setting = DAY;
	asteroid= FALSE;
	size = 1;
		/* Draw initial landscape, buttons, and traffic */
	draw_landscape(sun_x, sun_y, moon_x, moon_y, y1, y2,
		setting, boat_x, boat_y, boat_color, left_side_1, 
		base_1, biulding_color_1, left_side_2, base_2, 
		biulding_color_2, star_x, star_y);
	draw_buttons(setting);
	draw_traffic(truck_num,truck_x, truck_y, truck_color, 
			truck_direction, car_num, car_x, car_y, car_color, 
			car_direction, setting);
	draw_tree(tree_x, tree_y);

	/* Main event loop:
	 * ---- ----- -----
	 * Wait for the next user action, decode it, and call an
	 * appropriate function to handle it.  Repeat until the
	 * user selects quit. */

	quit = FALSE;
	while (!quit) {
	
			
		/* get next event */
		event = GP142_await_event(&mouse_x, &mouse_y, &key_pressed);
		
		/* perform appropriate action depending on kind of event */
		switch (event) {
		case GP142_QUIT:
			/* Quit selected */
			quit = TRUE;
			break;
			
		case GP142_KBD:
			/* Key pressed.  Not used now.  If the program should		*/
			/* react to keyboard events, insert something appropriate	*/
			/* here.  Note that scanf CANNOT be used with GP142.		*/
			break;
			
		case GP142_MOUSE:
			/* Mouse click.  Determine if in a menu button	*/
			/* or elsewhere and process accordingly.		*/
			click_kind = classify_mouse_click(mouse_x, mouse_y);
			if (click_kind == BUTTON_CLICK) {
				handle_button(mouse_x, mouse_y, &traffic_moving,
					&speed,	&car_num, car_direction, &truck_num, 
					truck_direction, car_color, truck_color, &asteroid);
				} 
			break;
			
		case GP142_PERIODIC:
			/* Timer interval event.  Update everything	*/
			/* that needs to change as time advances.	*/
			if(setting == DAY)
				move_sun(&sun_x, &sun_y, &moon_x);
			if(setting== NIGHT)
				move_moon(&moon_x, &moon_y, &sun_x);
			if (traffic_moving){
				move_traffic(car_x, truck_x, car_direction, 
						truck_direction, speed);
				move_boat(&boat_x, &boat_y, &boat_direction, 
							boat_speed);
				move_elavator(&y1, &y2);
			if(asteroid == TRUE)
				seattle_goes_boom(ast_x, ast_y, ast_x1, ast_y1, &size);
			}
			break;
			
		default:
				/* unknown event */
			break;
			
		}  /*end switch */
	/* Redraw everything */
		if(asteroid == TRUE) {
			draw_landscape_asteroid(ast_x, ast_y, ast_x1, ast_y1, 
						size);
		}
		else {
			boat_color = car_color[0];
		setting = draw_landscape(sun_x, sun_y, moon_x, moon_y, y1, y2,
			setting, boat_x, boat_y, boat_color, left_side_1, 
			base_1, biulding_color_1, left_side_2, base_2, 
			biulding_color_2, star_x, star_y);				
		draw_traffic(truck_num,truck_x, truck_y, truck_color, 
			truck_direction, car_num, car_x, car_y, car_color, 
			car_direction, setting);
		draw_tree(tree_x, tree_y);
		draw_buttons(setting);
		}
}  /* end event loop */
		
	/* Termination: shut down graphics window and exit */
	GP142_close();
	return 0;
}  /*end main */

/********************************************************************

     BACKGROUND LANDSCAPE

*********************************************************************/

/*Draw the background, including the sun at coordinates sun_x and sun_y*/
int draw_landscape(int sun_x, int sun_y, int moon_x, int moon_y, 
				   int y1, int y2, int setting, int boat_x, int boat_y, 
				   int boat_color, const int left_side_1[], 
				   const int base_1[], const int biulding_color_1[],
				   const int left_side_2[], const int base_2[], 
				   const int biulding_color_2[], const int star_x[],
				   const int star_y[]) {

	int text_offset = -GP142_XMAX + 15;	/*horizontal offset of text*/
	int text_size   = 12;				/* size of text font */
	int base, first, second;
	int third, i;		/*variables that store coordinates*/
	int color, exit;	/*variables that store color and exit option*/
	int windows = 14;	/*varaible that stores the number of windows*/
						/*Window number must be an even number*/

	/* Draw the sky during the day*/	
if(setting ==DAY) {
	GP142_rectangleXY(ICE_BLUE, -GP142_XMAX, -GP142_YMAX,
			GP142_XMAX, GP142_YMAX, FILL);
}
/*Draw the sky at night*/
else {
	GP142_rectangleXY(BLACK, -GP142_XMAX, -GP142_YMAX,
		GP142_XMAX, GP142_YMAX, FILL);
	
	for(i=0; i < NUM_STARS; i++){
		GP142_pixelXY(WHITE, star_x[i], star_y[i]);
	}
}

/* Draw the sun or moon */
if(setting ==DAY) {
	GP142_circleXY(ORANGE, sun_x, sun_y , 25);
}
	else {
	GP142_ovalXY(YELLOW, moon_x, moon_y, moon_x-35, moon_y-36, FILL);
	GP142_ovalXY(BLACK, moon_x-9, moon_y, moon_x-35, moon_y-36, FILL);
}

/* Draw the ground for daytime*/
if(setting ==DAY) {
	GP142_rectangleXY(BROWN, -GP142_XMAX, -GP142_YMAX,
		GP142_XMAX, HORIZON, FILL);

	GP142_rectangleXY(FOREST_GREEN, -25, -165, 110, HORIZON, FILL);

	GP142_ovalXY(LT_GRAY, 16, -123, 29, -124, 16);
	GP142_ovalXY(MED_GRAY, 16, -119, 29, -120, 16);
	GP142_ovalXY(BLUE, 16, -119, 29, -120, 12);

/*Draw mountains for daytime*/
	GP142_triangleXY(MED_GRAY,
		-GP142_XMAX, HORIZON,
		GP142_XMAX, HORIZON,
		0, (4 * GP142_YMAX)/5,
		FILL);

	GP142_triangleXY(WHITE,
		(2 *-GP142_XMAX)/9, ((HORIZON)+175) ,
		(2 *GP142_XMAX)/9, ((HORIZON)+175),
		0, (4 * (GP142_YMAX)/5), FILL);

	GP142_triangleXY(MED_GRAY,
		-GP142_XMAX -60, HORIZON +40,
		-GP142_XMAX +250, HORIZON +40,
		(3 *-GP142_XMAX)/4, (GP142_YMAX)/2,
		FILL);

	GP142_triangleXY(MED_GRAY,
		GP142_XMAX +40, HORIZON +40,
		GP142_XMAX - 202, HORIZON +40,
		(3 *GP142_XMAX)/4, (GP142_YMAX)/2 ,
		FILL);
	
		GP142_triangleXY(BLACK,
		-GP142_XMAX -60, HORIZON +40,
		-GP142_XMAX +250, HORIZON +40,
		(3 *-GP142_XMAX)/4, (GP142_YMAX)/2,
		1);

	GP142_triangleXY(BLACK,
		GP142_XMAX +40, HORIZON +40,
		GP142_XMAX - 202, HORIZON +40,
		(3 *GP142_XMAX)/4, (GP142_YMAX)/2 ,
		1);

}
else {

/*Draw the ground at night*/
	GP142_rectangleXY(MED_GRAY, -GP142_XMAX, -GP142_YMAX,
		GP142_XMAX, HORIZON, FILL);
	GP142_lineXY(RED, -GP142_XMAX, HORIZON, 
							GP142_XMAX, HORIZON,
							1);
	GP142_rectangleXY(FOREST_GREEN, -25, -165, 110, HORIZON, FILL);

	GP142_ovalXY(MED_GRAY, 16, -123, 29, -124, 16);
	GP142_ovalXY(LT_GRAY, 16, -119, 29, -120, 16);
	GP142_ovalXY(NAVY_BLUE, 16, -119, 29, -120, 12);

/*Draw some mountains at night*/	
	GP142_triangleXY(LT_GRAY,
		-GP142_XMAX, HORIZON,
		GP142_XMAX, HORIZON,
		0, (4 * GP142_YMAX)/5 ,
		FILL);
	GP142_triangleXY(YELLOW,
		-GP142_XMAX, HORIZON,
		GP142_XMAX, HORIZON,
		0, (4 * GP142_YMAX)/5 ,
		1);
	GP142_triangleXY(WHITE,
		(2 *-GP142_XMAX)/9, ((HORIZON)+175) ,
		(2 *GP142_XMAX)/9, ((HORIZON)+175),
		0, (4 * (GP142_YMAX)/5), FILL);
		GP142_triangleXY(LT_GRAY,
		-GP142_XMAX -60, HORIZON +40,
		-GP142_XMAX +250, HORIZON +40,
		(3 *-GP142_XMAX)/4, (GP142_YMAX)/2,
		FILL);

	GP142_triangleXY(LT_GRAY,
		GP142_XMAX +40, HORIZON +40,
		GP142_XMAX - 202, HORIZON +40,
		(3 *GP142_XMAX)/4, (GP142_YMAX)/2 ,
		FILL);
	
}
/* Draw lake for day or night*/
if(setting ==DAY) 
	color = BLUE;
else
	color = NAVY_BLUE;

	GP142_rectangleXY(color, 
					-GP142_XMAX, HORIZON- 20,
					 GP142_XMAX, HORIZON + 40,
					 FILL);
	GP142_ovalXY(color,-150, HORIZON-45, 169, HORIZON+23, FILL);

/*draw boat traffic*/
	draw_boat_traffic(boat_x, boat_y, boat_color, setting);

/*Draw Space Needle*/
	GP142_triangleXY(LT_GRAY, 
				10,HORIZON -50,
				40, HORIZON -50,
				25, HORIZON +35,
				FILL);
	GP142_triangleXY(BLACK, 
				10,HORIZON -50,
				40, HORIZON -50,
				25, HORIZON +35,
				1);
	/*Draw elevator for Space Needle*/
if(setting ==DAY) {
	GP142_rectangleXY(WHITE,
		24, y1,
		27, y2,
		FILL);
}
else {
	GP142_rectangleXY(YELLOW,
		24, y1,
		27, y2,
		FILL);
}
	GP142_rectangleXY(BLACK,
		24, y1,
		27, y2,
		1);
	GP142_ovalXY(LT_GRAY,
		5, HORIZON +25,
		45, HORIZON +45,
		FILL);
	GP142_ovalXY(BLACK,
		5, HORIZON +25,
		45, HORIZON +45,
		1);
if(setting == NIGHT)
	GP142_ovalXY(YELLOW,
		5, HORIZON +30,
		45, HORIZON +45,
		FILL);
else
	GP142_ovalXY(BLACK,
		5, HORIZON +30,
		45, HORIZON +45,
		FILL);
	GP142_ovalXY(LT_GRAY,
		5, HORIZON +35,
		45, HORIZON +45,
		FILL);
	GP142_ovalXY(BLACK,
		5, HORIZON +35,
		45, HORIZON +45,
		1);
	GP142_triangleXY(LT_GRAY, 
				20,HORIZON +40,
				30, HORIZON +40,
				25, HORIZON +60,
				FILL);
	GP142_triangleXY(BLACK, 
				20,HORIZON +40,
				30, HORIZON +40,
				25, HORIZON +60,
				1);
	GP142_pixelXY(RED, 25, HORIZON +60);
	GP142_lineXY(BLACK, 23, HORIZON -50,
				23, HORIZON +24, 2);
	GP142_lineXY(BLACK, 28, HORIZON -50,
				28, HORIZON +24, 2);
/*Draw biuldings*/
	draw_biulding_2(setting, windows, left_side_2, base_2, 
			biulding_color_2);

	draw_biulding(setting, windows, left_side_1, base_1, 
			biulding_color_1);
	
/****Draw first highway lane*/
	GP142_rectangleXY(WHITE, 
					-GP142_XMAX, HIGHWAY_CENTER - HIGHWAY_WIDTH,
					 GP142_XMAX, HIGHWAY_CENTER + HIGHWAY_WIDTH,
					 FILL);
	GP142_lineXY(YELLOW, -GP142_XMAX, HIGHWAY_CENTER, 
							GP142_XMAX, HIGHWAY_CENTER,
							3);
	GP142_lineXY(BLACK, -GP142_XMAX, HIGHWAY_CENTER, 
							GP142_XMAX, HIGHWAY_CENTER,
							1);
	GP142_printfXY (BLACK, text_offset, -GP142_YMAX+30, text_size,
		"Click a button to control the car.\n Designed by:\n Brian Altman");
/***Draw second lane of highway****/
	GP142_rectangleXY(WHITE, 
					-GP142_XMAX, HIGHWAY_CENTER - 20,
					 GP142_XMAX, HIGHWAY_CENTER - 40,
					 FILL);
	GP142_lineXY(YELLOW, -GP142_XMAX, HIGHWAY_CENTER - 30, 
							GP142_XMAX, HIGHWAY_CENTER - 30,
							3);
	GP142_lineXY(BLACK, -GP142_XMAX, HIGHWAY_CENTER - 30, 
							GP142_XMAX, HIGHWAY_CENTER - 30,
							1);
	GP142_lineXY(LT_GRAY, -GP142_XMAX, HIGHWAY_CENTER - 15, 
							GP142_XMAX, HIGHWAY_CENTER - 15,
							3);

/****Draw Lamp post**********/
if(setting == NIGHT)	{
	for(i = -GP142_XMAX; i <= GP142_XMAX +200 ; i += 65) {
		first = i; 
		second = (i +60);
		third = (i +30);
		base = HIGHWAY_CENTER + HIGHWAY_WIDTH + 3;

		GP142_triangleXY(WHITE, 
			first, base, 
			second, base, 
			third, base + 37, FILL);
		
		GP142_triangleXY(YELLOW,
			first, base,
			second, base,
			third, base + 37, 1);

			}
}
	for(i = -GP142_XMAX; i <= GP142_XMAX +200 ; i += 65) {
		third = (i +30);
		base = HIGHWAY_CENTER + HIGHWAY_WIDTH + 3;

		GP142_lineXY(BLACK, third, base, third, base + 40, 5);
		
		GP142_circleXY(BLACK, third, base + 37, 4);
	}
	if(setting == NIGHT) {
		 if(moon_x < -GP142_XMAX - 30)
			exit =DAY;
		else
			exit = NIGHT;
	}
	else if(setting == DAY) {
			if(sun_x < -GP142_XMAX -30)
				exit = NIGHT;
			else 
				exit = DAY;
	}
	return(exit);
} /*end draw_landscape */

/*****************************************************************************

     BUTTONS AND MOUSE CLICKS

*****************************************************************************/

/* Draws the buttons */
void draw_buttons(int setting) {
	int i;
	int text_offset = MENU_LEFT+10;	/* offset of button text in button */
	int font_size = 12;		/* size of button text */
	int color;

	/* draw rectangles for each button */
	for(i = 0; i < NUM_BUTTONS; i++) {
		GP142_rectangleXY(BLACK,
			MENU_LEFT,
			MENU_TOP - i * BUTTON_HEIGHT,
			MENU_LEFT + BUTTON_WIDTH,
			MENU_TOP - (i + 1)*BUTTON_HEIGHT, 2);
	}	
if(setting ==DAY) 
	color = NAVY_BLUE;
else 
	color = YELLOW;
	/* display button text */
	i = MENU_TOP - (BUTTON_HEIGHT/2) - (font_size/2);
	GP142_printfXY(FOREST_GREEN, text_offset, i, font_size, "Start Vehicles");	
	
	i -= BUTTON_HEIGHT;
	GP142_printfXY(RED, text_offset, i, font_size, "Stop Vehicles");

	i -= BUTTON_HEIGHT;
	GP142_printfXY(color, text_offset, i, font_size, "Faster");
	
	i -= BUTTON_HEIGHT;
	GP142_printfXY(color, text_offset, i, font_size, "Slower");
	
	i -= BUTTON_HEIGHT;
	GP142_printfXY(color, text_offset, i, font_size, "Reverse Cars");
	
	i -= BUTTON_HEIGHT;
	GP142_printfXY(color, text_offset, i, font_size, "Reverse Trucks");

	i -= BUTTON_HEIGHT;
	GP142_printfXY(RED, text_offset, i, font_size, "New Car Color");
	
	i -= BUTTON_HEIGHT;
	GP142_printfXY(RED, text_offset, i, font_size, "New Truck Color");

	i -= BUTTON_HEIGHT;
	GP142_printfXY(RED, text_offset, i, font_size, "Add Car");

	i -= BUTTON_HEIGHT;
	GP142_printfXY(RED, text_offset, i, font_size, "Add Truck");
	
		i -= BUTTON_HEIGHT;
	GP142_printfXY(WHITE, text_offset, i, font_size, "ASTEROID!!");
}
/* Classify mouse click at (mouse_x,mouse_y) and return kind */
int  classify_mouse_click(int mouse_x, int mouse_y)
{
	if ((mouse_x > MENU_LEFT) &&
		(mouse_x < MENU_LEFT + BUTTON_WIDTH) &&
		(mouse_y < MENU_TOP) &&
		(mouse_y > (MENU_TOP - NUM_BUTTONS*BUTTON_HEIGHT)))
		return BUTTON_CLICK;
	else
		return OTHER_CLICK;
}
/* Process button click at location x, y.  Update car speed,	*/
/* direction, color, and whether traffic is moving as needed.	*/
void handle_button(int x, int y, int *traffic_moving, int *car_speed,
				   int *car_num, int car_direction[], int *truck_num, 
				   int truck_direction[], int car_color[], 
				   int truck_color[], int *asteroid)
{
	int buttonNum;		/* number of selected button */
	int k;
	
	/* Convert y coordinate to button number from top. */
	buttonNum = (MENU_TOP - y)/BUTTON_HEIGHT;	 
	
	switch(buttonNum) {
	case 0:
		/* go */
		*traffic_moving = TRUE;
		break;
	case 1:
		/* stop */
		*traffic_moving = FALSE;
		break;
		
	case 2:
		/* speed up */
		*car_speed = *car_speed + 1;
		break;
	case 3:
		/* slow down */
		*car_speed = *car_speed - 1;
		if (*car_speed < 0)
			*car_speed = 0;
		break;
		
	case 4:
		/* reverse car direction for lane 1*/
		for(k = 0; k < NUM_CARS; k +=1) {
			car_direction[k] = -car_direction[k];
		}
		break;

	case 5:
		/* reverse car direction for lane 2*/
		for(k = 0; k < NUM_TRUCKS; k +=1) {
			truck_direction[k] = -truck_direction[k];
		}
		break;

	case 6:
		/* change car color */
	for(k = 0; k < NUM_CARS; k +=1) {	
	car_color[k] = (car_color[k]+1) % MAX_COLORS;
	}
		break;

	case 7:
		/* change truck color */
	for(k = 0; k < NUM_TRUCKS; k +=1) {	
	truck_color[k] = (truck_color[k]+1) % MAX_COLORS;
	}
		break;

	case 8:
		/* ADD Car */
		if(*car_num < NUM_CARS) 
			(*car_num) ++;
		break;

	case 9:
		/* ADD Truck */
		if(*truck_num < NUM_TRUCKS) 
		(*truck_num)++;
		break;

	case 10:
		/*ASTEROID*/
		*asteroid = TRUE;
		break;

	default:
		break;
	}
}
/********************************************************************

     TRAFFIC AND OTHER ANIMATED OBJECTS

*********************************************************************/

/* Update sun coordinates sun_x, sun_y by one tick */
void move_sun(int *sun_x, int *sun_y, int *moon_x) {
	/* Move the sun to the left. If it reaches the edge, move it */
	/* to the other side. */
		(*sun_x) -=3;		
	if (*sun_x < -GP142_XMAX -30)
		*moon_x = GP142_XMAX - 25;
}
/* Update moon coordinates moon_x, moon_y by one tick*/
void move_moon(int *moon_x, int *moon_y, int *sun_x) {
	(*moon_x) -=3;
	if (*moon_x < -GP142_XMAX - 30) 
		*sun_x =GP142_XMAX - 25;
}
/*Update Space Needle's elavator coordinates*/
void move_elavator(int *y1, int *y2) {
	(*y1) ++;
	(*y2) ++;
	if((*y1 > HORIZON +30)) {
		(*y1) = HORIZON -50;
		(*y2) = HORIZON -43;
	}
}
/* Update all vehicle x, y coordinates, given current x, y */
/* location, direction (+1 or -1), and speed in pixels per tick, */
void move_traffic(int car[], int truck[], int car_direction[], 
				  int truck_direction[], int speed) {	
	int k;
	int trial_car, trial_truck;		/* new value for x coordinate */

for(k = 0; k < NUM_CARS; k +=1) {	
	/* move vehicle.  If it moves off the edge, reverse direction */
	trial_car = car[k] + (car_direction[k] * speed);
	if (abs(trial_car) > GP142_XMAX + CAR_WIDTH/2)
		car[k] = - car[k];
	else
		car[k] = trial_car;

	(car[k]) ++;
}
for(k = 0; k < NUM_TRUCKS; k +=1) {	
	/* move vehicle.  If it moves off the edge, reverse direction */
	trial_truck = truck[k] + (truck_direction[k] * speed);
	if (abs(trial_truck) > GP142_XMAX + CAR_WIDTH/2)
		truck[k] = - truck[k];
	else
		truck[k] = trial_truck;

	(truck[k]) ++;
}
}
void move_boat(int *boat_x, int *boat_y, int *boat_direction, 
			   int boat_speed) {
	int trial_x;		/* new value for x coordinate */
	
		/* move vehicle. If it moves off the edge, reverse direction */
	trial_x = *boat_x + (*boat_direction * boat_speed);
	if (abs(trial_x) > GP142_XMAX + 30)
		*boat_x = - *boat_x;
	else
		*boat_x = trial_x;
}
/* Draw all vehicles given their current x, y coordinates and color */
void draw_traffic(int truck_num, const int truck_x[], const int truck_y[], 
				const int truck_color[], const int truck_direction[],
				int car_num, const int car_x[], const int car_y[], 
				const int car_color[], const int car_direction[], 
				int setting) {	
	draw_truck(truck_num, truck_x, truck_y, truck_color, 
					truck_direction, setting);
	draw_car(car_num, car_x, car_y, car_color, car_direction, setting);

}
void draw_boat_traffic(int x, int y, int boat_color, int setting) {
	draw_boat(x, y, boat_color, setting);
}
/* Draw a single car of the given color with horizontal */
/* center x and bottom y*/
void draw_car(int car_num, const int x[], const int y[], 
			  const int color[], const int car_direction[], 
			  int setting) {
	int k;
for(k = 0; k < car_num; k +=1) {
	GP142_rectangleXY(color[k],
		x[k] - CAR_WIDTH/2, y[k] + CAR_HEIGHT/4,
		x[k] + CAR_WIDTH/2, y[k] + CAR_HEIGHT*3/4,
		FILL);
	GP142_rectangleXY(color[k],
		x[k] - CAR_WIDTH/6, y[k] + CAR_HEIGHT*3/4,
		x[k] + CAR_WIDTH/6, y[k] + CAR_HEIGHT,
		FILL);
	GP142_circleXY(BLACK, x[k] - CAR_WIDTH/4, y[k] + CAR_HEIGHT/4, 
				CAR_HEIGHT/4);
	GP142_circleXY(BLACK, x[k] + CAR_WIDTH/4, y[k] + CAR_HEIGHT/4, 
				CAR_HEIGHT/4);
	
	if(setting == NIGHT) {
		if(car_direction[k] == -1) {
			GP142_triangleXY(YELLOW,
				x[k] - 2*CAR_WIDTH, y[k] + (CAR_HEIGHT/4) -5,
				x[k] - 2*CAR_WIDTH, y[k] + (CAR_HEIGHT*3/4) -9,
				x[k] - CAR_WIDTH/2, y[k] + CAR_HEIGHT/2,
				FILL);
			GP142_lineXY(RED,
				x[k] + CAR_WIDTH/2, y[k] + CAR_HEIGHT/3,
				x[k] + (CAR_WIDTH/2) +1, y[k] + CAR_HEIGHT/3,
				2);
		}
		else if(car_direction[k] == 1) {
			GP142_triangleXY(YELLOW,
				x[k] + 2*CAR_WIDTH, y[k] + (CAR_HEIGHT/4) -5,
				x[k] + 2*CAR_WIDTH, y[k] + (CAR_HEIGHT*3/4) -9,
				x[k] + CAR_WIDTH/2, y[k] + CAR_HEIGHT/2,
				FILL);
			GP142_lineXY(RED,
				x[k] - CAR_WIDTH/2, y[k] + CAR_HEIGHT/3,
				x[k] - (CAR_WIDTH/2) -1, y[k] + CAR_HEIGHT/3,
				2);
		}
	}
}
}
void draw_truck( int truck_num, const int x[], const int y[], 
				const int color[], const int truck_direction[], 
				int setting) {
	int k;

for(k = 0; k < truck_num; k +=1) {

if(truck_direction[k] == TRUE) {	

	if(setting == DAY) {	
		GP142_rectangleXY(color[k], 
				x[k] - CAR_WIDTH/6 +20, y[k] + CAR_HEIGHT*3/4,
				x[k] + CAR_WIDTH/6 +20, y[k] + CAR_HEIGHT, FILL);

		GP142_rectangleXY(color[k], 
					x[k] - CAR_WIDTH/3, y[k] + CAR_HEIGHT/4,
					x[k] + CAR_WIDTH-5, y[k] + CAR_HEIGHT*3/4, FILL);
	
		GP142_circleXY(BLACK, 
				x[k] - CAR_WIDTH/5 +5, y[k] + CAR_HEIGHT/4, 
				CAR_HEIGHT/4);
	
		GP142_circleXY(BLACK, 
				x[k] + CAR_WIDTH/2 +3, y[k] + CAR_HEIGHT/4, 
				CAR_HEIGHT/4);
	}
	else {	
		GP142_rectangleXY(color[k], 
				x[k] - CAR_WIDTH/6 +20, y[k]+ CAR_HEIGHT*3/4,
				x[k] + CAR_WIDTH/6 +20, y[k] + CAR_HEIGHT, FILL);

		GP142_rectangleXY(color[k], 
					x[k] - CAR_WIDTH/3, y[k] + CAR_HEIGHT/4,
					x[k] + CAR_WIDTH-5, y[k] + CAR_HEIGHT*3/4, FILL);
		
		GP142_circleXY(BLACK, 
				x[k] - CAR_WIDTH/5 +5, y[k] + CAR_HEIGHT/4, 
				CAR_HEIGHT/4);
	
		GP142_circleXY(BLACK, 
				x[k] + CAR_WIDTH/2 +3, y[k] + CAR_HEIGHT/4, 
				CAR_HEIGHT/4);

		GP142_triangleXY(YELLOW,
				x[k] + 2*CAR_WIDTH, y[k] + (CAR_HEIGHT/4) -4,
				x[k] + 2*CAR_WIDTH, y[k] + (CAR_HEIGHT*3/4) -7,
				x[k] + CAR_WIDTH/2 +15, y[k] + CAR_HEIGHT/2,
				FILL);
		GP142_lineXY(RED,
				x[k] - CAR_WIDTH/2 +7, y[k] + CAR_HEIGHT/3,
				x[k] - (CAR_WIDTH/2) +7, y[k] + CAR_HEIGHT/3,
				2);
	}

}
else {	
	if(setting == DAY) {	
		GP142_rectangleXY(color[k], 
				x[k] - CAR_WIDTH/6, y[k] + CAR_HEIGHT*3/4,
				x[k] + CAR_WIDTH/6, y[k] + CAR_HEIGHT, FILL);

		GP142_rectangleXY(color[k], 
					x[k] - CAR_WIDTH/3, y[k] + CAR_HEIGHT/4,
					x[k] + CAR_WIDTH-5, y[k] + CAR_HEIGHT*3/4, FILL);
	
		GP142_circleXY(BLACK, 
				x[k] - CAR_WIDTH/5 +5, y[k] + CAR_HEIGHT/4, 
				CAR_HEIGHT/4);
	
		GP142_circleXY(BLACK, 
				x[k] + CAR_WIDTH/2 +3, y[k] + CAR_HEIGHT/4, 
				CAR_HEIGHT/4);
	}
	else {	
			
		GP142_rectangleXY(color[k], 
				x[k] - CAR_WIDTH/6, y[k] + CAR_HEIGHT*3/4,
				x[k] + CAR_WIDTH/6, y[k] + CAR_HEIGHT, FILL);
	
		GP142_rectangleXY(color[k], 
					x[k] - CAR_WIDTH/3, y[k] + CAR_HEIGHT/4,
					x[k] + CAR_WIDTH-5, y[k] + CAR_HEIGHT*3/4, FILL);

		GP142_circleXY(BLACK, 
				x[k] - CAR_WIDTH/5 +5, y[k] + CAR_HEIGHT/4, 
				CAR_HEIGHT/4);
	
		GP142_circleXY(BLACK, 
				x[k] + CAR_WIDTH/2 +3, y[k] + CAR_HEIGHT/4, 
				CAR_HEIGHT/4);

		GP142_triangleXY(YELLOW,
				x[k] - 2*CAR_WIDTH, y[k] + (CAR_HEIGHT/4)-4,
				x[k] - 2*CAR_WIDTH, y[k] + (CAR_HEIGHT*3/4) -7,
				x[k] - CAR_WIDTH/2 +5, y[k] + CAR_HEIGHT/2,
				FILL);
		GP142_lineXY(RED,
				x[k] + CAR_WIDTH/2 +15, y[k] + CAR_HEIGHT/3,
				x[k] + (CAR_WIDTH/2) +15, y[k] + CAR_HEIGHT/3,
				2);
	}
}
}
}
void draw_boat(int x, int y, int boat_color, int setting) {
	GP142_rectangleXY(BLACK, 
		x - BOAT_WIDTH/3, y + BOAT_HEIGHT/4,
		x + BOAT_WIDTH+20, y + BOAT_HEIGHT*3/4, FILL);
	GP142_rectangleXY(boat_color, 
		x - BOAT_WIDTH/5, y + BOAT_HEIGHT*3/4,
		x + BOAT_WIDTH/5, y + BOAT_HEIGHT, FILL);
	GP142_triangleXY(BLACK,
		x + BOAT_WIDTH+20, y + BOAT_HEIGHT*3/4,
		x + BOAT_WIDTH+20, y + BOAT_HEIGHT/4,
		x + BOAT_WIDTH+29, y + BOAT_HEIGHT*3/4, FILL);
	GP142_lineXY(WHITE,
		x + BOAT_WIDTH/3, y + BOAT_HEIGHT*3/4 -2,
		x + BOAT_WIDTH+28, y + BOAT_HEIGHT*3/4 -2, 2);
if(setting == NIGHT){
		GP142_lineXY(YELLOW,
		x -13, y + BOAT_HEIGHT*3/4,
		x -13, y + BOAT_HEIGHT*3/4 -1, 2);
}
}
/*Function that draws biuldings*/
void draw_biulding(int setting, int windows, 
				   const int left_side[], 
				   const int base[], 
				   const int color[]) {
	int door_color, window_color;	/*variables that store*/ 
							/*the biuldings door and window color*/
	int k, i;
	
	if(setting == DAY) {
		door_color = MED_GRAY;
		window_color = BLACK;
	}
	else {
		door_color = YELLOW;
		window_color = YELLOW;
	}	
for(k = 0; k < NUM_BIULDING_1; k +=1) {
			/*biulding*/
		GP142_rectangleXY(color[k],
				left_side[k], base[k],
				left_side[k] + 64, base[k] + 100,
				FILL);
		GP142_rectangleXY(BLACK,
				left_side[k], base[k],
				left_side[k] + 64, base[k] + 100,
				1);
				/*windows*/
	for(i = 0; i <= (windows/2) * 10 ; i += 10) {
		GP142_rectangleXY(window_color,
				left_side[k] +10, base[k] + 13 + i,
				left_side[k] +20, base[k] +19 + i,
				FILL);
		GP142_rectangleXY(window_color,
				left_side[k] +27, base[k] + 13 + i,
				left_side[k] +38, base[k] + 19 + i,
				FILL);
		GP142_rectangleXY(window_color,
				left_side[k] +45, base[k] + 13 + i,
				left_side[k] +55, base[k] +19 + i,
				FILL);
		GP142_rectangleXY(BLACK,
				left_side[k] +10, base[k] + 13 + i,
				left_side[k] +20, base[k] +19 + i,
				1);
		GP142_rectangleXY(BLACK,
				left_side[k] +27, base[k] + 13 + i,
				left_side[k] +38, base[k] + 19 + i,
				1);
		GP142_rectangleXY(BLACK,
				left_side[k] +45, base[k]  + 13 + i,
				left_side[k]  +55, base[k]  +19 + i,
				1);
	}
			/*door*/
		GP142_rectangleXY(door_color,
				left_side[k]  +28 , base[k] ,
				left_side[k]  +36, base[k]  + 13,
				FILL);	
		GP142_rectangleXY(BLACK,
				left_side[k]  +28 , base[k] ,
				left_side[k]  +36, base[k]  + 13,
				1);
}
}
void draw_biulding_2(int setting, int windows, 
					 const int left_side[],
					 const int base[], 
					 const int color[]) {
	int window_color;	/*variable that stores window color*/
	int i, k;

	windows = (windows *2) -1;

	if(setting == DAY) 
		window_color = BLUE;
	else 
		window_color = YELLOW;
	

for(k = 0; k < NUM_BIULDING_2; k +=1) {
			/*biulding*/
	GP142_rectangleXY(color[k],
				left_side[k], base[k],
				left_side[k] + 54, base[k] + 150,
				FILL);
		GP142_rectangleXY(BLACK,
				left_side[k], base[k],
				left_side[k] + 54, base[k] + 150,
				1);
				/*windows*/
	for(i = 0; i <= (windows/2) * 10 ; i += 10) {
		GP142_rectangleXY(window_color,
				left_side[k] +5, base[k] + 9 + i,
				left_side[k] +13, base[k] +16 + i,
				FILL);
		GP142_rectangleXY(window_color,
				left_side[k] +23, base[k] + 9 + i,
				left_side[k] +31, base[k] + 16 + i,
				FILL);
		GP142_rectangleXY(window_color,
				left_side[k] +41, base[k] + 9 + i,
				left_side[k] +49, base[k] +16 + i,
				FILL);
		GP142_rectangleXY(BLACK,
				left_side[k] +5, base[k] + 9 + i,
				left_side[k] +13, base[k] +16 + i,
				1);
		GP142_rectangleXY(BLACK,
				left_side[k] +23, base[k] + 9 + i,
				left_side[k] +31, base[k] + 16 + i,
				1);
		GP142_rectangleXY(BLACK,
				left_side[k] +41, base[k] + 9 + i,
				left_side[k] +49, base[k] + 16 + i,
				1);
	}
}		
}
void draw_tree(const int tree_x[], const int tree_y[]) {
	int k;
for(k = 0; k < NUM_TREES; k +=1) {
	GP142_rectangleXY(BLACK, tree_x[k], tree_y[k], 
				  tree_x[k]+4, tree_y[k]+17, FILL);
	GP142_triangleXY(GREEN, 
				tree_x[k]-8, tree_y[k] +15, 
				tree_x[k] +12, tree_y[k]+15, 
				tree_x[k] +2, tree_y[k] +40, FILL);
}
}
/********************************************************************

     OTHER

*********************************************************************/

/*ASTEROID ACTION!!!!****/
void seattle_goes_boom(int ast_x[], int ast_y[], int ast_x1[],
							int ast_y1[], int *size) {
	int i;

for(i=0; i <= NUM_ASTEROID; i++) {
		(ast_x[i]) --;
		(ast_y[i]) --;
		(ast_x1[i]) ++ ;
		(ast_y1[i]) --;
}
for( i=0; i <(NUM_ASTEROID); i++) {
	if(ast_y1[i] < (HORIZON +50)) 
		(*size) ++;	
	if(ast_y[i] < (HORIZON +50)) 
		(*size) ++;		
	}
}
/* Draw ASTEROID landscape*/
void draw_landscape_asteroid(int ast_x[], int ast_y[], int ast_x1[],
							int ast_y1[], int size) {
	int k;
GP142_printfXY (RED, -135, 150, 18, "SAY GOOD BYE! YOU'RE GONNA DIE!!");

for(k = 0; k< NUM_ASTEROID; k++) { 
		GP142_circleXY(MED_GRAY, ast_x[k], ast_y[k], 8);
		GP142_circleXY(ORANGE, ast_x[k], ast_y[k], 7);
	
}
for(k = 0; k< (NUM_ASTEROID); k++)  {
		GP142_circleXY(MED_GRAY, ast_x1[k], ast_y1[k], 9);
		GP142_circleXY(ORANGE, ast_x1[k], ast_y1[k], 8);
}
for( k=0; k <(NUM_ASTEROID); k++) {
	if(ast_y1[k] < (HORIZON +50))
		GP142_circleXY(LT_GRAY, ast_x1[k], ast_y1[k], size);
	if(ast_y[k] < (HORIZON +50))
		GP142_circleXY(LT_GRAY, ast_x[k], ast_y[k], size);
}
}